<?php

namespace itguild\forms\inputs;

use itguild\forms\inputs\BaseInput;
use itguild\forms\templates\Simple\SimpleTemplate;
use itguild\forms\traits\CreateParams;

class File extends BaseInput
{
    use CreateParams;
    private string $name;
    private array $paramsArray;
    private string $multiple;

    /**
     * @param string $name
     * @param array $paramsArray
     */

    public function __construct(string $name, array $paramsArray = [])
    {
        $this->name = $name;
        $this->paramsArray = $paramsArray;
        $this->inputTemplate = new SimpleTemplate();
        $this->multiple = '';
    }

    /**
     * @return self
     */
    public function create(): self
    {
        $paramsString = $this->createParams($this->paramsArray);
        $input = "<input type='file' name='$this->name' $this->multiple $paramsString >";

        $this->createLabel();

        $this->html = str_replace('{input}', $input, $this->inputTemplate->getInputTemplate());
        $this->html = str_replace('{label}', $this->labelString, $this->html);

        return $this;
    }

    /**
     * @param string $name
     * @param array $paramsArray
     * @return void
     */
    public static function build(string $name, array $paramsArray = []): void
    {
        $input = new self($name, $paramsArray);
        $input->create()->render();
    }

    public function setMultiple(): void
    {
            $this->multiple = 'multiple';
    }
}